{
   IMU Simple Test

   Sungyong Kim
   sungyong615@hotmail.com
   03/10/2010
    
<<<<<<<<<<<<<<<<<<<<< Prop Pin Outs >>>>>>>>>>>>>>>>>>>>

Used Pins for interfacing various things to Prop
16~19 TV    Output
24 IMU LED
25~27 IMU
'Prop' to MCP' comm's pins
    CS  = 25
    DIO = 26
    CLK = 27                                                      
}
CON
  
' NAME        PIN#  / VALUE
' ----------- ------- ----------  

  _CLKMODE            = XTAL1 + PLL16X
  _XINFREQ            = 5_000_000

'    _clkmode = xtal2 + pll8x
'    _xinfreq = 10_000_000

' Video Output Assignments                              
  TVBase    = 16    'TV base pin 16~19         

' IMU and Range
  LED       = 24    ' Port with 'alive' LED 

' Prop' to MCP' comm's pins
  IMU_CS    = 25
  IMU_DIO   = 26
  IMU_CLK   = 27
 
                                                                                                          
VAR
  long stackInit[130]                  ' Sets up a stack space for Radio Control Receiver [increase if more servos]
  long pitch, dPitch, tPitch
  long roll, dRoll, tRoll
  long yaw
   
OBJ                                                    
  clock      :  "Clock"               ' overall timers 
  tv         :  "tv_text"             ' TV video output driver
  imu        :  "IMU-Range"
  number     :  "DynamicMathLib"
  conv       :  "FloatMath"
  ftos       :  "FloatString"

PUB start

Clock.Init(_XINFREQ)                  ' set up clock for accurate 10/second
Clock.SetClock(_CLKMODE)              ' video update rate
Clock.MarkSync

cognew(Init_Screen,@stackInit)

tv.start(TVBase)                      ' Start TV display
tv.str(string($E,13,$E,1,$E,33))      ' Set TV line                            

' ------- start IMU startup -------
imu.start( IMU_CS, IMU_DIO, IMU_CLK, 0 )                                                      

Init_Screen                           ' Print Data Layout Screen
Init_Screen                                           
Get_Data                              ' Get data
     
PUB Get_Data                          ' Get data from IMU
repeat                                ' Keep updating data
     IMU_Range                        ' Print IMU data on TV
     waitcnt(25000000 + cnt)        
      


Pub Init_Screen        'Set Inishall OSD Screen
    tv.out($0)
  
'                  0         1         2         3        
'                  0123456789012345678901234567890123456789

    tv.str(string("IMU Kalman Filter TEST                 ",13))    'setup the tv screen graphics layout
    tv.str(string("Pitch Angle:                           ",13))    '1
    tv.str(string("Roll  Angle:                           ",13))    '2
    tv.str(string("Z Axis     :                           ",13))    '3
    tv.str(string("Pitch Rate :                           ",13))    '4
    tv.str(string("Roll  Rate :                           ",13))    '5

'                  0         1         2         3        
'                  0123456789012345678901234567890123456789

Pub IMU_Range

{
    yaw    := ftos.FloatToString(imu.get_z_axis)
    pitch  := conv.FRound(conv.FMul(imu.get_angle_Pitch, conv.FFloat(10)))
    dPitch := conv.FRound(conv.FMul(imu.get_rate_Pitch,  conv.FFloat(10)))
    roll   := conv.FRound(conv.FMul(imu.get_angle_Roll,  conv.FFloat(10)))
    dRoll  := conv.FRound(conv.FMul(imu.get_rate_Roll,   conv.FFloat(10)))
}
    pitch  := imu.get_angle_Pitch
    roll   := imu.get_angle_Roll
    yaw    := imu.get_z_axis
    dPitch := imu.get_rate_Pitch
    dRoll  := imu.get_rate_Roll

    tv.str(string($A,13,$B,1))   ' set to col 13 on line 1                                   
    tv.dec(pitch)
    tv.str(string($A,13,$B,2))   ' set to col 13 on line 2                                   
    tv.dec(roll)
    tv.str(string($A,13,$B,3))   ' set to col 13 on line 3                                   
    tv.dec(yaw)
    tv.str(string($A,13,$B,4))   ' set to col 13 on line 4                                   
    tv.dec(dPitch)
    tv.str(string($A,13,$B,5))   ' set to col 13 on line 5                                   
    tv.dec(dRoll)
    dira[ LED ]~~
    !outa[ LED ]
       